
#include "si5351mcu.h"

Si5351mcu Si;

long F1 =  3853100;  //    3853.1 KHz to CLK0
long F2 =  7878100;  //    7878.1 KHz to CLK0

long Fakt;
long Fakt_old;
long val = 0;
long val_old;

//////////////////////////////////////////////////////////////
void setup() {
    pinMode(0,INPUT_PULLUP);    // ch-select via PB0 ( Pin5 )  
    pinMode(1,OUTPUT);          // switching output via PB1 ( Pin6 )  
    Si.init(25000000);          // Fx = 25MHz   
    Si.setPower(0, SIOUT_8mA);
    Si.setFreq(0, F1);
    Si.reset();
    Si.enable(0);
}

///////////////////////////////////////////////////////////////////////
void loop() 
{
        if(digitalRead(0)==HIGH) { Fakt=F1; digitalWrite(1,HIGH); }
   else if(digitalRead(0)==LOW)  { Fakt=F2; digitalWrite(1,LOW);  }

// fine-tuning via ADC A1 
   int analogPin = A1;                 // analog-in via A1(Pin7)  
   val = analogRead(analogPin);        // val = 0 - 1023
   val = map(val,0,1023,-20,20);    
   
   if(val!=val_old)      
   { 
   Fakt=Fakt+(val*100); 
   Si.setFreq(0,Fakt);
//   Si.reset();
   Si.enable(0); 
   val_old=val; 
   }

   if(Fakt<(Fakt_old-10000)||Fakt>(Fakt_old+10000))      
   { 
   Si.setFreq(0,Fakt);
   Si.reset();
   Si.enable(0); 
   Fakt_old=Fakt; 
   val_old = 0;
   }
}
