/*
 * si5351mcu - Si5351 library for Arduino, MCU tuned for size and click-less
 *
 * This is the packed simplest example.
 *
 * Copyright (C) 2017 Pavel Milanes <pavelmc@gmail.com>
 *
 * Many chunk of codes are derived-from/copied from other libs
 * all GNU GPL licenced:
 *  - Linux Kernel (www.kernel.org)
 *  - Hans Summers libs and demo code (qrp-labs.com)
 *  - Etherkit (NT7S) Si5351 libs on github
 *  - DK7IH example.
 *  - Jerry Gaffke integer routines for the bitx20 group
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "si5351mcu.h"

Si5351mcu Si;

long F1 =     3853100;  // USB 3853.1 KHz to CLK0
long F2 =     7878100;  // USB 7878.1 KHz to CLK0
long F3 =     3856900;  // LSB 3856.9 KHz to CLK0
long F4 =     7881900;  // LSB 7881.9 KHz to CLK0

long F_aktuell;
long F_old;

//////////////////////////////////////////////////////////////
void setup() {
    pinMode(0,INPUT_PULLUP);    // frequency-select via PB0 ( Pin5 )  
    pinMode(1,OUTPUT);          // out level via PB1 ( Pin6 )  
    pinMode(2,INPUT_PULLUP);    // usb/osb-select via PB2 ( Pin7 )  
    Si.init(25000000);          // Fx = 25MHz   
    Si.setPower(0, SIOUT_8mA);
    Si.setFreq(0, F1);
    Si.reset();
    Si.enable(0);
}

///////////////////////////////////////////////////////////////////////
void loop() 
{
     if(digitalRead(0)==LOW &&digitalRead(2)==HIGH) { F_aktuell=F2 ; digitalWrite(1,LOW ) ; } 
else if(digitalRead(0)==HIGH&&digitalRead(2)==HIGH) { F_aktuell=F1 ; digitalWrite(1,HIGH) ; } 
else if(digitalRead(0)==LOW &&digitalRead(2)==LOW)  { F_aktuell=F4 ; digitalWrite(1,LOW)  ; } 
else if(digitalRead(0)==HIGH&&digitalRead(2)==LOW)  { F_aktuell=F3 ; digitalWrite(1,HIGH) ; } 
 
     if(F_aktuell!=F_old) 
    { Si.setFreq(0,F_aktuell);
      Si.reset();
      Si.enable(0); 
      F_old=F_aktuell; }
}
